"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRuntimeConfig = exports.resolveEntrypoints = exports.printPluginHelp = exports.loadPlugin = void 0;
var dedent_1 = __importDefault(require("dedent"));
var path = __importStar(require("path"));
function validatePlugin(plugin, packageName) {
    if (typeof plugin.resolveBundleEntrypoints !== "function") {
        throw new Error("Bad plugin package: " + packageName + "\nShould export a function \"resolveBundleEntrypoints\".");
    }
}
function loadPluginModule(packageName, pluginName) {
    var searchPaths = [
        path.join(process.cwd(), "node_modules")
    ];
    try {
        var modulePath = require.resolve(packageName, { paths: searchPaths });
        return require(modulePath);
    }
    catch (error) {
        throw new Error("Cannot load plugin " + pluginName + ". Module could not be loaded: " + packageName + "\n\n" +
            "Try installing the module:\n\n" +
            ("    npm install --save-dev " + packageName + "\n\n") +
            ("Caught error: " + error.message + "\n"));
    }
}
function loadPlugin(entrypointArgument) {
    var pluginName = entrypointArgument.replace(/^plugin:/, "");
    var packageName = pluginName.startsWith("puppet-run-plugin-")
        ? pluginName
        : "puppet-run-plugin-" + pluginName;
    var loadedModule = loadPluginModule(packageName, pluginName);
    validatePlugin(loadedModule, packageName);
    return __assign(__assign({}, loadedModule), { packageName: packageName });
}
exports.loadPlugin = loadPlugin;
function printPluginHelp(plugin, scriptArgs) {
    if (plugin.help) {
        // tslint:disable-next-line:no-console
        console.log(dedent_1.default(plugin.help(scriptArgs)));
    }
    else {
        // tslint:disable-next-line:no-console
        console.log(dedent_1.default("\n      " + plugin.packageName + "\n\n      No plugin help available.\n    "));
    }
}
exports.printPluginHelp = printPluginHelp;
function resolveEntrypoints(plugins, initialEntrypoints, scriptArgs) {
    return __awaiter(this, void 0, void 0, function () {
        var entrypoints, plugins_1, plugins_1_1, plugin, _a, e_1_1;
        var e_1, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    entrypoints = initialEntrypoints;
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 8, 9, 10]);
                    plugins_1 = __values(plugins), plugins_1_1 = plugins_1.next();
                    _c.label = 2;
                case 2:
                    if (!!plugins_1_1.done) return [3 /*break*/, 7];
                    plugin = plugins_1_1.value;
                    if (!plugin.resolveBundleEntrypoints) return [3 /*break*/, 4];
                    return [4 /*yield*/, plugin.resolveBundleEntrypoints(entrypoints, scriptArgs)];
                case 3:
                    _a = _c.sent();
                    return [3 /*break*/, 5];
                case 4:
                    _a = entrypoints;
                    _c.label = 5;
                case 5:
                    entrypoints = _a;
                    _c.label = 6;
                case 6:
                    plugins_1_1 = plugins_1.next();
                    return [3 /*break*/, 2];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_1_1 = _c.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (plugins_1_1 && !plugins_1_1.done && (_b = plugins_1.return)) _b.call(plugins_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 10: return [2 /*return*/, entrypoints];
            }
        });
    });
}
exports.resolveEntrypoints = resolveEntrypoints;
function createRuntimeConfig(plugins, scriptArgs) {
    return __awaiter(this, void 0, void 0, function () {
        var config, plugins_2, plugins_2_1, plugin, _a, e_2_1;
        var e_2, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    config = {};
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 8, 9, 10]);
                    plugins_2 = __values(plugins), plugins_2_1 = plugins_2.next();
                    _c.label = 2;
                case 2:
                    if (!!plugins_2_1.done) return [3 /*break*/, 7];
                    plugin = plugins_2_1.value;
                    if (!plugin.extendPuppetDotPlugins) return [3 /*break*/, 4];
                    return [4 /*yield*/, plugin.extendPuppetDotPlugins(config, scriptArgs)];
                case 3:
                    _a = _c.sent();
                    return [3 /*break*/, 5];
                case 4:
                    _a = config;
                    _c.label = 5;
                case 5:
                    config = _a;
                    _c.label = 6;
                case 6:
                    plugins_2_1 = plugins_2.next();
                    return [3 /*break*/, 2];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_2_1 = _c.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (plugins_2_1 && !plugins_2_1.done && (_b = plugins_2.return)) _b.call(plugins_2);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 10: return [2 /*return*/, config];
            }
        });
    });
}
exports.createRuntimeConfig = createRuntimeConfig;
